
#ifndef GENERATION_METHODS_ELECTRUM_H
#define GENERATION_METHODS_ELECTRUM_H


#include "GenerationParameters.h"
#include "ExtendedKey.h"
#include "extraInfo.h"
#include "mnemonic.h"


#include <string>

#include "GenerationInfo.h"

class GenerationMethodsElectrum
{
public:

	static void createElectrumMnemonic(const GenerationInfoCore infoCore, const std::string& mnemonicRaw, const std::list<ExtraInfo>& extra);
	static void createElectrumRandom(const GenerationInfoCore infoCore, const int numWords);
	static void createElectrumHash(const GenerationInfoCore infoCore, const int numWords, const std::string& hash);
	static void createElectrumHex(const GenerationInfoCore infoCore, const int numWords, const std::string& hex);
	static void createElectrumDice(const GenerationInfoCore infoCore, const int numWords, const std::string& diceStr);
	static void createElectrumBrain(const GenerationInfoCore infoCore, const int numWords, const std::string& salt, const std::string& brainVal);

private:
		//const std::string& thetime, 
		//const GenerationParameters& params, 

	static void generateElectrumMnemonicInfo(const GenerationInfoCore infoCore,
		const BigInt<256>& randomNum, 
		const int numWords, 
		const std::string& genMethod, 
		const std::list<ExtraInfo>& extra);

	static void saveElectrumMnemonic(const GenerationInfo& info, const std::list<ExtraInfo>& extra, const ExtendedPrivateKey& extendedPrivate);

/*const ElectrumMnemonic& mnemonic,*/
		//const std::string& thetime,const ElectrumMnemonic& mnemonic, 
		//const std::string& genMethod, const GenerationParameters& params,
		//const std::list<ExtraInfo>& extra);

};



#endif
