
#ifndef GENERATION_METHODS_EXTENDED_H
#define GENERATION_METHODS_EXTENDED_H


#include "GenerationParameters.h"
#include "ExtendedKey.h"
#include "extraInfo.h"
#include "mnemonic.h"


#include <string>

#include "GenerationInfo.h"

class GenerationMethodsExtended
{
public:
	static void createExtendedMnemonic(const GenerationInfoCore& infoCore, const std::string& mnemonicRaw); //const std::string& thetime, const std::string& mnemonicRaw, const GenerationParameters& params);

	static void saveExtendedFiles(const AddressGenerationInfo& allInfo,	const ExtendedPublicKey& extPublic, const bool isElectrum);

//const std::string& extPrivate, 
	//const std::string& generator,
	//const std::string& thetime, const GenerationParameters& params, const std::list<ExtraInfo>& generationExtra, 
	//const std::string& derivationPath,
	//const MnemonicBase& mnemonic,
	
	
	//const std::string& extPrivate, 
	//	const ExtendedPublicKey& extPublic, const std::string& generator,
	//	const std::string& thetime, const GenerationParameters& params, const std::list<ExtraInfo>& generationExtra, 
	//	const std::string& derivationPath, const MnemonicBase& mnemonic, const bool isElectrum = false);

	static void createExtendedDice(const GenerationInfoCore& infoCore, const std::string& diceval); //const std::string& thetime, const std::string& diceval, const GenerationParameters& params);

	static void createExtendedHash(const GenerationInfoCore& infoCore, const std::string& hashval); //const std::string& thetime, const std::string& hashval, const GenerationParameters& params);
	
	static void createExtendedHex(const GenerationInfoCore& infoCore, const std::string& hexhval); //const std::string& thetime, const std::string& hexhval, const GenerationParameters& params);

	static void createExtendedRandom(const GenerationInfoCore& infoCore); //const std::string& thetime, const GenerationParameters& params);

	static void createExtendedExtBrain(const GenerationInfoCore& infoCore, const std::string& salt, const std::string& brainVal); //const std::string& thetime, const std::string& salt, const std::string& brainVal, const GenerationParameters& params);
	static void createExtendedExtPriv(const GenerationInfoCore& infoCore, const std::string& exprivVal); //const std::string& thetime, const std::string& exprivVal, const GenerationParameters& params);
	static void createExtendedSeed(const GenerationInfoCore infoCore, const std::string& hashval); //const std::string& thetime, const std::string& hashval, const GenerationParameters& params);


};



#endif
