/**
 * GenerationMethods.cpp - Bitcoin address generator
 *
 * Copyright (C)2015 The bitgen developers <bitgen@openmailbox.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */
 
/**
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE. 
*/
 


#include "EntryInfoSet.h"

#include <string>


class InformationList
{
public:	

static std::string createOtpListTxtFile(const EntroInfoSet& infoSet, const double sum, const double priceSum, const int padnum, const int totalPads,  const std::string& thetime, const bool listAll,
	int& numEntries);
static std::string createOtpListPsFile(const EntroInfoSet& infoSet, const std::string& folder, const int padnum, const int totalPads,  const std::string& thetime, const std::string& name,
	const bool listAll);
static std::string createPubOtpListPsFile(const EntroInfoSet& infoSet, const double sum, const double priceSum, const std::string& folder,  const std::string& thetime, const std::string& name, const bool listAll);
static void listPublicFolderContents(const std::string& pubFolder, const std::string& thetime, const std::string& name, const bool listAll);

static void generateOtpListForPad(const std::list<std::string>& folders, const int numPad, const std::string& thetime, const std::string& name, const bool listAll);
private:

static void listFolderContents(const std::string& folder, const int padnum, const int totalPads, const std::string& thetime, const std::string& name, const bool listAll);

};

