#pragma once



#include "EntryInfoSet.h"

#include <set>

class OtpFolderHandler
{
public:
	static std::string getPrivPadTotFolder(const std::string& folder, const int numPad);

	static std::string getPublicTotFolder(const std::string& pubFolder);

	static EntroInfoSet getPublicOtpInfoList(const std::string& folder);
	static EntroInfoSet getPrivOtpInfoList(const std::string& folder, const int padnum);

	static EntryInfo readEntryInfo(const std::string& dir, const int num, const int padnum);

	static std::string getPubEmptyFile(const std::string& pubFolder, const int addressNum);
	static std::string getPrivEmptyFile(const std::string& privFolder, const int padnum, const int addressNum);

	static std::string getTotalPrivFolder(const std::string& pubFolder, const int padnum, const int addressNum);

private:
	static int getDirEntryNum(const std::string& dir, const std::string prefix = "priv");
	static std::string removeWhitespaceEnd(const std::string& str);
	static std::pair<std::string, std::string> splitColon(const std::string& line);
	static std::string getTheFilename(const std::set<std::string>& directories, const int num);
	static EntryInfo readPubEntryInfo(const std::string& baseDir, const int num, const bool isEmptyAmount);
	static std::string getTotalPubFolder(const std::string& pubFolder, const int addressNum);
	static std::string getMyPubFolder(const std::string& pubFolder, const int addressNum);
	static bool pubEmptyFileExists(const std::string& pubFolder, const int addressNum);	
};








