#!/usr/bin/python

import os
import sys
import os.path

def printHeader(str) :
   "Prints header text"
   print "===================== " + str + " ====================="
   return

if not os.path.isfile("../bitgen-xmr"):
	print "Error, application binary does not exist"
	sys.exit()

#============ Start of tests ============

retval1 = os.system("../bitgen-xmr setnextnum 36")
if retval1 != 0:
	print "test init error"
	sys.exit()


printHeader("Test 1 bitgen-xmr derive")
retval1 = os.system("../bitgen-xmr derive \"lofty rekindle oval adventure kept whale bodies lukewarm fictional jeans avidly vitals aisle fabrics baffles tasked archer dodge birth ointment origin hence nodes opposite hence\" | tee output_xmr.txt")
if retval1 != 0:
	print "test 1 error"
	sys.exit()


if not os.path.isfile("output_xmr.txt"):
	print "test 1 file error"
	sys.exit()


with open("output_xmr.txt") as f:
	content1 = f.read()  
	#print content1
	if "44ffvdzb2T8b5wxtyNQjHA5Apj5NFrxjHc7Y5HH2CqKuCgocuswjX3NBByJzkRRb2EFi8kpBSQdFCDagQvfETJVe7Pi4Fea" not in content1: 
		print "test 1 file error 1"
		sys.exit()

	if "87fDTGGh23VbYaRYomtTmtBJBnnGosMWWeTh6n2gGbbPci17xA37YQgcDt2GJdKc2VWwiSi3VNgXwbhZvLxAxZVr4RTScu7" not in content1: 
		print "test 1 file error 2"
		sys.exit()

	if "87xHv2BTMR6exzeePksysv6XjtcQMMj8pdwS1az4ZUBZcf4K9EzDwXiexKV8eGPegT2AdqJg9zzhMctXvMDM391ZUfGyqxp" not in content1: 
		print "test 1 file error 3"
		sys.exit()

	if "84UXdrVLhzNXenneLpJHbJ3Zv622B56es8R3ZvKJao9kGMkxnsr5hEk15zqYU9vcGZ1NuP3XDWLVNZAFi2vxn6eCPnpx7Z3" not in content1: 
		print "test 1 file error 4"
		sys.exit()

	if "8A9NTMSbqDRbggrD71keCVYZXBzobhwwzPhjDSfu5LVGGYSk32LM3nXiBhnHgiZm2XVyPCnMxSQoLMH4JvLYmbZ9GCrSNdQ" not in content1: 
		print "test 1 file error 5"
		sys.exit()



#---------------------------------------------------------------------

printHeader("Test 2 bitgen-xmr hash")
retval1 = os.system("../bitgen-xmr hash hhhhhhhhhhhrwerwerwerwerwerwewerwerhhhhhhhhhhhhhfufuufufufusdfisydfiusdyfuisdyfuisdyfuisdyfiusdyfuisdyfuisdyfuisdyfiusdyfuisdyfuisydfuiysduifysduiyuysdfuysduifysduifysduifysudyfyyfyfyyfyfyfyfysdyfusydfuisdyfiusfsdf")
if retval1 != 0:
	print "test 2 error"
	sys.exit()


if not os.path.isfile("xmr_address_36_4Aw5hkTG_private.txt"):
	print "test 2 file error"
	sys.exit()


if not os.path.isfile("xmr_address_36_4Aw5hkTG_share.txt"):
	print "test 2 file error"
	sys.exit()


with open("xmr_address_36_4Aw5hkTG_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "4Aw5hkTGQ3zCZtZFp77hPxLdvtSUp64nRJtE9qXfA77CK6BKftoRgVvj9MfvqLV5gS9WTdR1cW6SrjRSrsGxFTn3DcbyaaZ" not in content1: 
		print "test 2 file error 1"
		sys.exit()

	if "pelican nagged nodes inkling jive toaster nugget leech estate jailed fuselage binocular sewage juggled bounced upbeat dummy dubbed aquarium hydrogen itches visited lesson likewise binocular" not in content1: 
		print "test 2 file error 2"
		sys.exit()


#sys.exit()

#---------------------------------------------------------------------

printHeader("Test 3 bitgen-xmr dice")
retval1 = os.system("../bitgen-xmr dice 6152435612435612341562435612435614356142356412563412312323123322224254254254254254254254242424244242")
if retval1 != 0:
	print "test 3 error"
	sys.exit()


if not os.path.isfile("xmr_address_37_46uCscYX_private.txt"):
	print "test 3 file error"
	sys.exit()


if not os.path.isfile("xmr_address_37_46uCscYX_share.txt"):
	print "test 3 file error"
	sys.exit()


with open("xmr_address_37_46uCscYX_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "46uCscYX1SQK5mVFwGBZ2BaFN2BTU5FdfMHQyFoMNdGK76uSWatyn4Qc4Ra8jEis2ef65TbextvU1UesdJstdbD9FE5Y38N" not in content1: 
		print "test 3 file error 1"
		sys.exit()

	if "koala dude vexed foiled science meeting flippant torch vein woozy dusted metro alpine woven lottery unwind gopher volcano tufts situated idiom tomorrow village vinegar flippant" not in content1: 
		print "test 2 file error 2"
		sys.exit()

#---------------------------------------------------------------------


printHeader("Test 4 bitgen-xmr hex")
retval1 = os.system("../bitgen-xmr hex 81276312786312763781236ABAABABBCBCBBCBCBBEFDFDFFEFEFFEFDFDFFE656")
if retval1 != 0:
	print "test 4 error"
	sys.exit()


if not os.path.isfile("xmr_address_38_446Jus9P_private.txt"):
	print "test 4 file error"
	sys.exit()


if not os.path.isfile("xmr_address_38_446Jus9P_share.txt"):
	print "test 4 file error"
	sys.exit()


with open("xmr_address_38_446Jus9P_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "446Jus9P7c6bSFWgA7TGszd8Z6C7u4m9EdEv8okRVwn5F8MbWYnaPvFSVubzQLsMzH7dCRChfTKBP4b3nGTGBq8nGznZp9v" not in content1: 
		print "test 4 file error 1"
		sys.exit()

	if "tuition loaded nozzle noodles bumper fuming rally always rabbits ditch gags ignore bunch pulp ingested verification cell haggled aimless whipped javelin nucleus upgrade upstairs always" not in content1: 
		print "test 4 file error 2"
		sys.exit()


#---------------------------------------------------------------------


printHeader("Test 5 bitgen-xmr mnemonic")
retval1 = os.system("../bitgen-xmr mnemonic \"jingle succeed acquire cohesive juvenile voice tepid affair novelty paradise patio rekindle woozy snout duckling plus cogs subtly ignore tarnished costume hashing skirting tail costume\"")
if retval1 != 0:
	print "test 5 error"
	sys.exit()


if not os.path.isfile("xmr_address_39_44mCVnHN_private.txt"):
	print "test 5 file error"
	sys.exit()


if not os.path.isfile("xmr_address_39_44mCVnHN_share.txt"):
	print "test 5 file error"
	sys.exit()


with open("xmr_address_39_44mCVnHN_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "44mCVnHNa1CRFy1FbWbE4a9Md2tbD4zobZxUigmDgf9xbpAVPCfJzeC3hRrG64Gv6wdUMy3UTqXhD3CvN8pHNqHMNh86zEN" not in content1: 
		print "test 5 file error 1"
		sys.exit()

	if "jingle succeed acquire cohesive juvenile voice tepid affair novelty paradise patio rekindle woozy snout duckling plus cogs subtly ignore tarnished costume hashing skirting tail costume" not in content1: 
		print "test 5 file error 2"
		sys.exit()


#---------------------------------------------------------------------


printHeader("Test 6 bitgen-xmr brainwallet")
retval1 = os.system("../bitgen-xmr brainwallet my@email.com \"My little PasSphrase tO test thiS stuFfff. Workking god.\"")
if retval1 != 0:
	print "test 6 error"
	sys.exit()


if not os.path.isfile("xmr_address_40_42r7c4ha_private.txt"):
	print "test 6 file error"
	sys.exit()


if not os.path.isfile("xmr_address_40_42r7c4ha_share.txt"):
	print "test 6 file error"
	sys.exit()


with open("xmr_address_40_42r7c4ha_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "42r7c4ha6gc1uYhQFhw6pXD6tvT1WAGsmZWno8bsdKoTc8HzAf7NxJwRvwLTfUhgp1MgZa4DPW5NfA27HaLeV7UF26cwAAf" not in content1: 
		print "test 6 file error 1"
		sys.exit()

	if "rash error dusted dying ozone online innocent dehydrate geyser sowed last hope arena jackets nineteen emotion amused cavernous robot recipe toffee vexed king looking error" not in content1: 
		print "test 6 file error 2"
		sys.exit()




printHeader("Test 7 bitgen-xmr priv")
retval1 = os.system("../bitgen-xmr priv 350E82717D4DCF05D9BF11814573EEA515EDFEA3702E851BE9AEB63E8BF2C203")
if retval1 != 0:
	print "test 7 error"
	sys.exit()


if not os.path.isfile("xmr_address_41_45YpN3mJ_private.txt"):
	print "test 7 file error"
	sys.exit()


if not os.path.isfile("xmr_address_41_45YpN3mJ_share.txt"):
	print "test 7 file error"
	sys.exit()


with open("xmr_address_41_45YpN3mJ_private.txt") as f:
	content1 = f.read()  
	#print content1
	if "45YpN3mJ7itMRQ22tZJgVVEXW5RHqospLXm4MvbKfXeSGkJxNP81H87TcyfJgkuNyx3f8BA4V6vEcFkaqBUrry8ZQHqS8Yg" not in content1: 
		print "test 7 file error 1"
		sys.exit()

	if "dangerous kiosk upgrade soothe plotting putty buying cowl point sewage revamp hairy pebbles frown voyage glass withdrawn awkward rarest pirate unwind pancakes lower masterful dangerous" not in content1: 
		print "test 7 file error 2"
		sys.exit()




print ""
print ""
print ""
print "Cleaning up"
os.system("rm *.txt *.ps")

print ""
print ""
print ""
print "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
print "++++++++++++++++++++++++++++++ All tests passed OK +++++++++++++++++++++++++++"
print "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"


sys.exit(123)
